/**
 *          
 *
 * @author   ,   ,  , 
 * @version 19/11/2007
 */

public class PhoneBook
{
	private Contact[] pbook;
	private int numOfContacts;
	
	public PhoneBook()
	{
		this.pbook = new Contact[100];  //  
		this.numOfContacts = 0;
	}
	
	public void addContact(String name, String phone)
	{
		int index = getContactIndex(name);

		if(index != -1)
			this.pbook[index].setPhone(phone);
		else
		{
			if(this.numOfContacts==this.pbook.length) //    -       
			{
				Contact[] temp = new Contact[this.pbook.length + 100]; //   
				for (int i = 0; i < this.pbook.length; i++)
					temp[i] = this.pbook[i];
				this.pbook = temp;
			}
			this.pbook[this.numOfContacts] = new Contact(name,phone);
			this.numOfContacts++;
		}
	}
	
	public void delContact(String name)
	{
		int index = getContactIndex(name);
		
		if(index != -1)
		{
			this.numOfContacts--;
			this.pbook[index] = this.pbook[this.numOfContacts];
			this.pbook[this.numOfContacts] = null;
		}
	}	
	
	public String getPhone(String name)
	{
		int index = getContactIndex(name);

		if(index != -1)
			return this.pbook[index].getPhone();
		
		return null;
	}

	
	public String[] getAllContactsNames()
	{
		//       
		String[] namesArr = new String[this.numOfContacts];

		for (int i = 0; i < this.numOfContacts; i++)
			namesArr[i] = this.pbook[i].getName();
		
		return namesArr;
	}
	
	//              
	//      
	public String toString()
	{
		//   
		String[] namesArr = this.getAllContactsNames();
		sortNames(namesArr);
	
		String str = "";
		for (int i = 0; i < namesArr.length; i++)
			str = str + String.format("%-20s %10s\n", namesArr[i], this.getPhone(namesArr[i]));
		
		return str;
	}
	
	//             .
	// -1           
	private int getContactIndex(String name)
	{		
		for (int i = 0; i < this.numOfContacts; i++)
			if(this.pbook[i].getName().equals(name))
				return i;
		
		return -1;
	}
	
	//           
	private void sortNames(String[] names)
	{
		String temp;
		
		for (int i = 1; i < names.length; i++)
		{
			for (int j = 0; j < names.length-i; j++)
			{
				if(names[j].compareToIgnoreCase(names[j+1])>0)
				{
					temp = names[j];
					names[j] = names[j+1];
					names[j+1] = temp;
				}
			}
		}
	}
}